import java.awt.*;
import javax.swing.*;

class OutVariable extends Gate
{  CoordinateArea coordArea;
   private boolean input1=false;
   private boolean output1=input1;
   private String name;

  public OutVariable(int x, int y, CoordinateArea ca )
  {
   this.coordArea=ca;
   width = 50; height = 25;
   this.x = x; this.y = y;
   name = "z" + (y-5);
   compute();
  }
 public void changeInputState(int inputpinnum)
 {
   input1=!input1;
   compute();
   setSimbolicOutput(coordArea.controller.numOutvar);
 }

 public Point scaleLocation(int x, int y)
 {
   return new Point(x*width, y* height);
 }

 public boolean inputValue (int inputpinnum)
 {
   return input1;
 }

 public boolean outputValue (int pinnum)
 {
   return output1;
 }

 public void compute()
 {
   if (output1!=input1)
       output1=input1;

 }

 public void setSimbolicOutput(int nOutVar)
  {int i,indice=0;
     for (i= 0; i<coordArea.gates.size() && nOutVar>0; i++)
       { Gate temp=(Gate) coordArea.gates.elementAt(i);
         while(!temp.isOutVariable())
         {
          i++;
          if(i<coordArea.gates.size())
          temp=(Gate) coordArea.gates.elementAt(i);

         }
        nOutVar=nOutVar-1;
        if (temp.outputValue(1))
        indice=indice+(int) Math.pow((double) 2,(double) nOutVar);
       }
     coordArea.simbolicOutput=" " + indice;
     if (coordArea.outputName.size()>indice)
     {TextField t=(TextField) coordArea.outputName.elementAt(indice);
     coordArea.simbolicOutput=t.getText();
      }
  }

  
 public Gate selected(Point point)
 {
   if (((point.x/width)==x)&&((point.y/height)==y))
       return this;
       return null;
 }
 public int selectedLocation(Point point)
 {
   return 1;
 }
 public int outputSelected(Point point)
 { Point scaled = scaleLocation(point.x, point.y);
   if((point.x > scaled.x + 35) && (point.y > scaled.y + 5) && // return true if near output
     (point.x < scaled.x + width) && (point.y < scaled.y + height - 5))
   return 3;
   return 0;
 }

 public int inputSelected(Point point)
 {
   Point scaled = scaleLocation(x,y);
    if ((point.x > scaled.x - 10) && (point.y > scaled.y - 5) && // if near input pins
            (point.x < scaled.x + 10) && (point.y < scaled.y + 25) &&
            (point.y < scaled.y + 10))
                return 1;                 // return constant 1
        else                              // otherwise not near input pins
            return 0;                     // return constant 0
 }

 public void paintGate(Graphics g)
 {
  Point scaled = scaleLocation(x,y);
  g.setFont(new Font("Helvetica", Font.PLAIN, 12));
  g.drawString (name,scaled.x+20, scaled.y);
  g.drawOval(scaled.x,scaled.y,5,5);
 }

 public void paintValues(Graphics g)
 {
  Point scaled = scaleLocation(x,y);
  g.setFont(new Font ("Helvetica", Font.PLAIN, 8));
  Color oldColor=  g.getColor();
  g.setColor(Color.red);
  g.drawString(output1 ? " 1" : " 0" , scaled.x + 10, scaled.y);
  g.setColor(oldColor);


 }
 public boolean isVariable()
 { return false;}

 public boolean isRingVariable()
 { return false;}

   public boolean isOutVariable()
    {return true;} 
}
