
//Title:        Sequential Circuit
//Version:      
//Copyright:    Copyright (c) 1998
//Author:       Ferrarello Daniela
//Company:      UNICT
//Description:  Your description

import java.awt.*;
import java.util.Vector;
import java.awt.event.*;

public class StepByStep extends Dialog
{ Circuit controller;
  BorderLayout borderLayout1 = new BorderLayout();
  Panel statisimbolici = new Panel();
  Panel bottoniera = new Panel();
  Button button1 = new Button();
  Button button2 = new Button();
  GridLayout gridLayout2 = new GridLayout();
  Panel input = new Panel();
  Panel output = new Panel();
  Panel statiinterni = new Panel();
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  GridLayout gridLayout3 = new GridLayout();
  GridLayout gridLayout4 = new GridLayout();
  GridLayout gridLayout5 = new GridLayout();
  Choice choiceInput = new Choice();
  TextField textRing = new TextField(15);
  TextField textOutput = new TextField(15);
  Vector simbolicInputName=new Vector();
  Vector simbolicOutputName=new Vector();
  Vector simbolicStateName=new Vector();
  int maxStep=10;
  int step=0;
  int i;

  public StepByStep(Circuit c,Frame frame, String title, boolean modal)
  { super(frame, title, modal);
    try
    {
      this.controller=c;
      jbInit();
    }
    catch(Exception ex)
    {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    this.setLayout(borderLayout1);
    this.setSize(600,400);
    button1.setLabel("STEP");
    button1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        button1_actionPerformed(e);
      }
    });
    button2.setLabel("EXIT");
    button2.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        button2_actionPerformed(e);
      }
    });
    statisimbolici.setLayout(gridLayout2);
    gridLayout2.setColumns(3);
    gridLayout2.setHgap(5);
    label1.setText("Symbolic input sequence");
    label2.setText("Next internal state sequence");
    label3.setText("Symbolic output sequence");
    input.setLayout(gridLayout3);
    gridLayout3.setRows(maxStep+1);
    statiinterni.setLayout(gridLayout4);
    output.setLayout(gridLayout5);
    gridLayout4.setRows(maxStep+1);
    gridLayout5.setRows(maxStep+1);
    textRing.setEnabled(false);
    textRing.setEditable(false);
    textOutput.setEnabled(false);
    textOutput.setEditable(false);
    this.add(statisimbolici, BorderLayout.CENTER);
    statisimbolici.add(input, null);
    input.add(label1, null);
    choiceInput=controller.boxedArea.coordinateArea.simbolicInputList;
    for(i=0;i<maxStep;i++)
      {
       simbolicInputName.addElement(new Choice());
      }
    for(i=0;i<maxStep;i++)
     {Choice tempchoice=(Choice) simbolicInputName.elementAt(i);
      input.add(tempchoice, null);
      tempchoice.removeAll();
      for(int j=0;j<choiceInput.getItemCount();j++)
       tempchoice.addItem(choiceInput.getItem(j));
     }
    statisimbolici.add(statiinterni, null);
    statiinterni.add(label2, null);
    for(i=0;i<maxStep;i++)
      {
       simbolicStateName.addElement(new TextField());
      }
    for(i=0;i<maxStep;i++)
     {
      TextField t=(TextField) simbolicStateName.elementAt(i);
      statiinterni.add(t, null);
     }
    statisimbolici.add(output, null);
    output.add(label3, null);
    for(i=0;i<maxStep;i++)
      {
       simbolicOutputName.addElement(new TextField());
      }
     for(i=0;i<maxStep;i++)
     {
      TextField t=(TextField) simbolicOutputName.elementAt(i);
      output.add(t, null);
     }
    this.add(bottoniera, BorderLayout.SOUTH);
    bottoniera.add(button1, null);
    bottoniera.add(button2, null);
  }

  boolean button1_actionPerformed(ActionEvent e)
  { if(step<maxStep)
    {
     boolean v = false;
     Choice ch = (Choice) simbolicInputName.elementAt(step);
     controller.boxedArea.coordinateArea.simbolicInput = ch.getSelectedItem();
     int number = ch.getSelectedIndex();
     int q = number;
     int i;
     for (i = controller.boxedArea.coordinateArea.gates.size()-1; i >= 0; i--)
        { Gate temp=(Gate) controller.boxedArea.coordinateArea.gates.elementAt(i);
          while(!temp.isVariable())
            {
             i--;
             if(i<0) break;
             temp=(Gate) controller.boxedArea.coordinateArea.gates.elementAt(i);
            }
          if(i>=0)
           {
            v=(( (q%2)==1) ?true:false);
            if (temp.inputValue(1)!=v)
                temp.changeInputState(1);
            q=q/2;
           }
         }
      //codice per far andare il clock!
       Gate tg=null;
       String ring = new String("RingVariable");
       if (controller.sequential)
        {
         for (int index = 0;index< controller.boxedArea.coordinateArea.gates.size();index++)
             {tg=(Gate) controller.boxedArea.coordinateArea.gates.elementAt(index);
              if(ring.compareTo(tg.getClass().getName())==0)
                 tg.compute();
             }
        }
       TextField tInternal = (TextField) simbolicStateName.elementAt(step);
       TextField tOutput = (TextField) simbolicOutputName.elementAt(step);
       tInternal.setText(controller.boxedArea.coordinateArea.simbolicState);
       tOutput.setText(controller.boxedArea.coordinateArea.simbolicOutput);
       controller.boxedArea.repaint();
       step++;
       return true;
      }
      else
       {
        this.setVisible(false);
        return true;
       }
  }

  boolean button2_actionPerformed(ActionEvent e)
  {
   this.setVisible(false);
   return false;

  }
}